#include <stdlib.h>
#include <stdio.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <string.h>
#include <math.h>
#include <errno.h>
//include the path here to Mygsl.h
#include </opt/csound516/Mygsl.h>

PDFS Mygsl_pitch_dists(int distribnumber, int counter, const gsl_rng * r)
{
    unsigned int yy;
    int distribution = distribnumber;
    int distcounter = counter;
    int pdfcounter= 0;
    PDFS mystruct;

//****************************************
//********  GSL DISTRIBTUIONS    *********
//****************************************
//the following distributions return type double

    if (distribution == 1)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGAUSSIAN(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for sigma, Ex. (0.65): ");
            scanf("%lf",&sigma);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_gaussian (r, sigma);
            mystruct.rand_pdf = gsl_ran_gaussian_pdf (mystruct.randistribution, sigma);
            mystruct.rand_cdf_P = gsl_cdf_gaussian_P (mystruct.randistribution, sigma);
            mystruct.rand_cdf_Q = gsl_cdf_gaussian_Q (mystruct.randistribution, sigma);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_gaussian (r, sigma);
            mystruct.rand_pdf = gsl_ran_gaussian_pdf (mystruct.randistribution, sigma);
            mystruct.rand_cdf_P = gsl_cdf_gaussian_P (mystruct.randistribution, sigma);
            mystruct.rand_cdf_Q = gsl_cdf_gaussian_Q (mystruct.randistribution, sigma);
        }
    }

    if (distribution == 2)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGAUSSIAN_TAIL(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a value for 'a' and sigma,\
                   \nwhere 'a' is positive, Ex. (0.45, 0.65): ");
            scanf("%lf, %lf",&a, &sigma);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_gaussian_tail (r, a, sigma);
            mystruct.rand_pdf = gsl_ran_gaussian_tail_pdf (mystruct.randistribution, a, sigma);
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_gaussian_tail (r, a, sigma);
            mystruct.rand_pdf = gsl_ran_gaussian_tail_pdf (mystruct.randistribution, a, sigma);
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A
        }
    }

    if (distribution == 3)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tEXPONENTIAL(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for mu, Ex. (0.65): ");
            scanf("%lf",&mu);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_exponential (r, mu);
            mystruct.rand_pdf = gsl_ran_exponential_pdf (mystruct.randistribution, mu);
            mystruct.rand_cdf_P = gsl_cdf_exponential_P (mystruct.randistribution, mu);
            mystruct.rand_cdf_Q = gsl_cdf_exponential_Q (mystruct.randistribution, mu);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_exponential (r, mu);
            mystruct.rand_pdf = gsl_ran_exponential_pdf (mystruct.randistribution, mu);
            mystruct.rand_cdf_P = gsl_cdf_exponential_P (mystruct.randistribution, mu);
            mystruct.rand_cdf_Q = gsl_cdf_exponential_Q (mystruct.randistribution, mu);
        }
    }

    if (distribution == 4)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLAPLACE(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for 'a', Ex. (0.65): ");
            scanf("%lf",&a);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_laplace (r, a);
            mystruct.rand_pdf = gsl_ran_laplace_pdf (mystruct.randistribution, a);
            mystruct.rand_cdf_P = gsl_cdf_laplace_P (mystruct.randistribution, a);
            mystruct.rand_cdf_Q = gsl_cdf_laplace_Q (mystruct.randistribution, a);
        }
        else
        {
            reset_laplace:
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            gsl_ran_laplace (r, a);  //additional call to avoid nan error
            mystruct.randistribution = gsl_ran_laplace (r, a);
            mystruct.rand_pdf = gsl_ran_laplace_pdf (mystruct.randistribution, a);
            //to avoid NAN error from the GSL distribution
            if(mystruct.rand_pdf!=mystruct.rand_pdf)
            {
                goto reset_laplace;
                pdfcounter++;
                if (pdfcounter > 1000)
                {
                    mystruct.rand_pdf = 0.0;
                    goto cont_laplace;
                }
            }
            cont_laplace:
            pdfcounter = 0;
            mystruct.rand_cdf_P = gsl_cdf_laplace_P (mystruct.randistribution, a);
            mystruct.rand_cdf_Q = gsl_cdf_laplace_Q (mystruct.randistribution, a);
        }
    }

    if (distribution == 5)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tEXPPOW(GSL) DISTRIBUTION\n");
            printf("\n");
            //For b = 1 this reduces to the Laplace distribution.
            //For b = 2 it has the same form as a Gaussian distribution.
            printf("Enter a values for 'a' and 'b',\
                   \nwhere a and b are positive, Ex. (0.45, 0.65): ");
            scanf("%lf, %lf",&a, &b);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_exppow (r, a, b);
            mystruct.rand_pdf = gsl_ran_exppow_pdf (mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_exppow_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_exppow_Q (mystruct.randistribution, a, b);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_exppow (r, a, b);
            mystruct.rand_pdf = gsl_ran_exppow_pdf (mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_exppow_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_exppow_Q (mystruct.randistribution, a, b);
        }
    }

    if (distribution == 6)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tCAUCHY(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for 'a', Ex. (0.65): ");
            scanf("%lf",&a);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_cauchy (r, a);
            mystruct.rand_pdf = gsl_ran_cauchy_pdf (mystruct.randistribution, a);
            mystruct.rand_cdf_P = gsl_cdf_cauchy_P (mystruct.randistribution, a);
            mystruct.rand_cdf_Q = gsl_cdf_cauchy_Q (mystruct.randistribution, a);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_cauchy (r, a);
            gsl_ran_cauchy_pdf (mystruct.randistribution, a); //additional call to avoid nan error
            mystruct.rand_pdf = gsl_ran_cauchy_pdf (mystruct.randistribution, a);
            mystruct.rand_cdf_P = gsl_cdf_cauchy_P (mystruct.randistribution, a);
            mystruct.rand_cdf_Q = gsl_cdf_cauchy_Q (mystruct.randistribution, a);
        }
    }

    if (distribution == 7)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tRAYLEIGH(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for sigma, Ex. (0.65): ");
            scanf("%lf",&sigma);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_rayleigh (r, sigma);
            mystruct.rand_pdf = gsl_ran_rayleigh_pdf (mystruct.randistribution, sigma);
            mystruct.rand_cdf_P = gsl_cdf_rayleigh_P (mystruct.randistribution, sigma);
            mystruct.rand_cdf_Q = gsl_cdf_rayleigh_Q (mystruct.randistribution, sigma);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            gsl_ran_rayleigh (r, sigma); //additional call to avoid nan error
            mystruct.randistribution = gsl_ran_rayleigh (r, sigma);
            mystruct.rand_pdf = gsl_ran_rayleigh_pdf (mystruct.randistribution, sigma);
            mystruct.rand_cdf_P = gsl_cdf_rayleigh_P (mystruct.randistribution, sigma);
            mystruct.rand_cdf_Q = gsl_cdf_rayleigh_Q (mystruct.randistribution, sigma);
        }
    }

    if (distribution == 8)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tRAYLEIGH_TAIL(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a value for 'a' and sigma,\
                   \nwhere 'a' is positive, Ex. (0.45, 0.65): ");
            scanf("%lf, %lf",&a, &sigma);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_rayleigh_tail (r, a, sigma);
            mystruct.rand_pdf = gsl_ran_rayleigh_tail_pdf (mystruct.randistribution, a, sigma);
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_rayleigh_tail (r, a, sigma);
            mystruct.rand_pdf = gsl_ran_rayleigh_tail_pdf (mystruct.randistribution, a, sigma);
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A
        }
    }

    if (distribution == 9)  //returned pdfs are quite low for this dist
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLANDAU(GSL) DISTRIBUTION\n");
            printf("\n");
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_landau (r);
            mystruct.rand_pdf = gsl_ran_landau_pdf (mystruct.randistribution);
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_landau (r);
            mystruct.rand_pdf = gsl_ran_landau_pdf (mystruct.randistribution);
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A
        }
    }

    if (distribution == 10)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLEVY(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a value for 'c' and alpha,\
                   \nwhere 0<alpha<=2, Ex. (0.65, 1.0): ");
            scanf("%lf, %lf",&c, &alpha);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_levy (r, c, alpha);
            mystruct.rand_pdf = 0.0; //N/A
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_levy (r, c, alpha);
            mystruct.rand_pdf = 0.0; //N/A
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A
        }
    }

    if (distribution == 11)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLEVY_SKEW(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a value for 'c', alpha, and beta\
                   \nwhere 0<alpha<=2, Ex. (0.65, 1.0, 0.43): ");
            scanf("%lf, %lf, %lf",&c, &alpha, &beta);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_levy_skew (r, c, alpha, beta);
            mystruct.rand_pdf = 0.0; //N/A
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A

        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_levy_skew (r, c, alpha, beta);
            mystruct.rand_pdf = 0.0; //N/A
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A
        }
    }

    if (distribution == 12)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGAMMA(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a value for 'a' and 'b',\
                   \nEx. (1.0, 0.65): ");
            scanf("%lf, %lf",&a, &b);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_gamma (r, a, b);
            mystruct.rand_pdf = gsl_ran_gamma_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_gamma_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_gamma_Q (mystruct.randistribution, a, b);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_gamma (r, a, b);
            mystruct.rand_pdf = gsl_ran_gamma_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_gamma_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_gamma_Q (mystruct.randistribution, a, b);
        }
    }

    if (distribution == 13)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tFLAT(normal)(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a value for 'a' and 'b',\
                   \nEx. (0.45, 0.65): ");
            scanf("%lf, %lf",&a, &b);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_flat (r, a, b);
            mystruct.rand_pdf = gsl_ran_flat_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_flat_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_flat_Q (mystruct.randistribution, a, b);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_flat (r, a, b);
            mystruct.rand_pdf = gsl_ran_flat_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_flat_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_flat_Q (mystruct.randistribution, a, b);
        }
    }

    if (distribution == 14)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLOGNORMAL(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter values for 'zeta' and 'sigma',\
                   \nEx. (0.45, 0.65): ");
            scanf("%lf, %lf",&zeta, &sigma);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_lognormal (r, zeta, sigma);
            mystruct.rand_pdf = gsl_ran_lognormal_pdf(mystruct.randistribution, zeta, sigma);
            mystruct.rand_cdf_P = gsl_cdf_lognormal_P (mystruct.randistribution, zeta, sigma);
            mystruct.rand_cdf_Q = gsl_cdf_lognormal_Q (mystruct.randistribution, zeta, sigma);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_lognormal (r, zeta, sigma);
            mystruct.rand_pdf = gsl_ran_lognormal_pdf(mystruct.randistribution, zeta, sigma);
            mystruct.rand_cdf_P = gsl_cdf_lognormal_P (mystruct.randistribution, zeta, sigma);
            mystruct.rand_cdf_Q = gsl_cdf_lognormal_Q (mystruct.randistribution, zeta, sigma);
        }
    }

    if (distribution == 15)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tCHISQ(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for nu, Ex. (0.65): ");
            scanf("%lf",&nu);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_chisq (r, nu);
            mystruct.rand_pdf = gsl_ran_chisq_pdf(mystruct.randistribution, nu);
            mystruct.rand_cdf_P = gsl_cdf_chisq_P (mystruct.randistribution, nu);
            mystruct.rand_cdf_Q = gsl_cdf_chisq_Q (mystruct.randistribution, nu);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_chisq (r, nu);
            mystruct.rand_pdf = gsl_ran_chisq_pdf(mystruct.randistribution, nu);
            mystruct.rand_cdf_P = gsl_cdf_chisq_P (mystruct.randistribution, nu);
            mystruct.rand_cdf_Q = gsl_cdf_chisq_Q (mystruct.randistribution, nu);
        }
    }

    if (distribution == 16)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tF-(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter values for 'nu1' and 'nu2',\
                   \nEx. (1.50, 0.75): ");
            scanf("%lf, %lf",&nu1, &nu2);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_fdist (r, nu1, nu2);
            mystruct.rand_pdf = gsl_ran_fdist_pdf(mystruct.randistribution, nu1, nu2);
            mystruct.rand_cdf_P = gsl_cdf_fdist_P (mystruct.randistribution, nu1, nu2);
            mystruct.rand_cdf_Q = gsl_cdf_fdist_Q (mystruct.randistribution, nu1, nu2);

        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_fdist (r, nu1, nu2);
            mystruct.rand_pdf = gsl_ran_fdist_pdf(mystruct.randistribution, nu1, nu2);
            mystruct.rand_cdf_P = gsl_cdf_fdist_P (mystruct.randistribution, nu1, nu2);
            mystruct.rand_cdf_Q = gsl_cdf_fdist_Q (mystruct.randistribution, nu1, nu2);
        }
    }

    if (distribution == 17)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tt-(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for nu, Ex. (0.65): ");
            scanf("%lf",&nu);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_tdist (r, nu);
            mystruct.rand_pdf = gsl_ran_tdist_pdf(mystruct.randistribution, nu);
            mystruct.rand_cdf_P = gsl_cdf_tdist_P (mystruct.randistribution, nu);
            mystruct.rand_cdf_Q = gsl_cdf_tdist_Q (mystruct.randistribution, nu);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_tdist (r, nu);
            mystruct.rand_pdf = gsl_ran_tdist_pdf(mystruct.randistribution, nu);
            mystruct.rand_cdf_P = gsl_cdf_tdist_P (mystruct.randistribution, nu);
            mystruct.rand_cdf_Q = gsl_cdf_tdist_Q (mystruct.randistribution, nu);
        }
    }

    if (distribution == 18)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tBETA(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a value for 'a', and 'b'\
                   \nbetween 0 and 1, Ex. (0.65, 0.43): ");
            scanf("%lf, %lf",&a, &b);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_beta (r, a, b);
            mystruct.rand_pdf = gsl_ran_beta_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_beta_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_beta_Q (mystruct.randistribution, a, b);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_beta (r, a, b);
            mystruct.rand_pdf = gsl_ran_beta_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_beta_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_beta_Q (mystruct.randistribution, a, b);
        }
    }

    if (distribution == 19)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLOGISTIC(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for 'a', Ex. (0.65): ");
            scanf("%lf",&a);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_logistic (r, a);
            mystruct.rand_pdf = gsl_ran_logistic_pdf(mystruct.randistribution, a);
            mystruct.rand_cdf_P = gsl_cdf_logistic_P (mystruct.randistribution, a);
            mystruct.rand_cdf_Q = gsl_cdf_logistic_Q (mystruct.randistribution, a);
        }
        else
        {
            reset_logistic:
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            gsl_ran_logistic (r, a); //additional call to avoid nan error
            mystruct.randistribution = gsl_ran_logistic (r, a);
            mystruct.rand_pdf = gsl_ran_logistic_pdf(mystruct.randistribution, a);
            //to avoid NAN error from the GSL distribution
            if(mystruct.rand_pdf!=mystruct.rand_pdf)
            {
                goto reset_logistic;
                pdfcounter++;
                if (pdfcounter > 1000)
                {
                    mystruct.rand_pdf = 0.0;
                    goto cont_logistic;
                }
            }
            cont_logistic:
            pdfcounter = 0;
            mystruct.rand_cdf_P = gsl_cdf_logistic_P (mystruct.randistribution, a);
            mystruct.rand_cdf_Q = gsl_cdf_logistic_Q (mystruct.randistribution, a);
        }
    }

    if (distribution == 20)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tPARETO(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a value for 'a', and 'b'\
                   \nEx. (0.65, 0.43): ");
            scanf("%lf, %lf",&a, &b);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_pareto (r, a, b);
            mystruct.rand_pdf = gsl_ran_pareto_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_pareto_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_pareto_Q (mystruct.randistribution, a, b);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_pareto (r, a, b);
            mystruct.rand_pdf = gsl_ran_pareto_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_pareto_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_pareto_Q (mystruct.randistribution, a, b);
        }
    }

    if (distribution == 21)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tWEIBULL(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a value for 'a', and 'b'\
                   \nEx. (0.65, 0.43): ");
            scanf("%lf, %lf",&a, &b);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_weibull (r, a, b);
            mystruct.rand_pdf = gsl_ran_weibull_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_weibull_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_weibull_Q (mystruct.randistribution, a, b);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_weibull (r, a, b);
            mystruct.rand_pdf = gsl_ran_weibull_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_weibull_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_weibull_Q (mystruct.randistribution, a, b);
        }
    }

    if (distribution == 22)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGUMBEL1(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a value for 'a', and 'b'\
                   \nEx. (0.65, 0.43): ");
            scanf("%lf, %lf",&a, &b);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_gumbel1 (r, a, b);
            mystruct.rand_pdf = gsl_ran_gumbel1_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_gumbel1_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_gumbel1_Q (mystruct.randistribution, a, b);
        }
        else
        {
            reset_gumbel1:
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_gumbel1 (r, a, b);
            mystruct.rand_pdf = gsl_ran_gumbel1_pdf(mystruct.randistribution, a, b);
             //to avoid NAN error from the GSL distribution
            if(mystruct.rand_pdf!=mystruct.rand_pdf)
            {
                goto reset_gumbel1;
                pdfcounter++;
                if (pdfcounter > 1000)
                {
                    mystruct.rand_pdf = 0.0;
                    goto cont_gumbel1;
                }
            }
            cont_gumbel1:
            mystruct.rand_cdf_P = gsl_cdf_gumbel1_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_gumbel1_Q (mystruct.randistribution, a, b);
        }
    }

    if (distribution == 23)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGUMBEL2(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a value for 'a', and 'b'\
                   \nEx. (0.65, 0.43): ");
            scanf("%lf, %lf",&a, &b);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_gumbel2 (r, a, b);
            mystruct.rand_pdf = gsl_ran_gumbel2_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_gumbel2_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_gumbel2_Q (mystruct.randistribution, a, b);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            mystruct.randistribution = gsl_ran_gumbel2 (r, a, b);
            mystruct.rand_pdf = gsl_ran_gumbel2_pdf(mystruct.randistribution, a, b);
            mystruct.rand_cdf_P = gsl_cdf_gumbel2_P (mystruct.randistribution, a, b);
            mystruct.rand_cdf_Q = gsl_cdf_gumbel2_Q (mystruct.randistribution, a, b);
        }
    }

    // The following discrete distribution types return unsigned int
    // but are converted to double by division of '1'.
    if (distribution == 24)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tPOISSON(GSL) DISTRIBUTION\n");
            //    printf("\t\t\t***** PITCHES *****");
            // The Poisson distribution tend towards
            // YY = 2, 3, or 4, where mystruct.randistribution = .5, .33, or .25
            // Thus pitches.c f=(int)(u*h-1)+1 will reject all except 2 or .5.
            // For these two distributions the lowest midi pitch should be 1,
            // then use sort pitches to transpose into audible range.
            printf("\n");
            printf("Enter a double value for mu, Ex. (3.314): ");
            scanf("%lf", &mu);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_poisson (r, mu);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_poisson_pdf(yy, mu);
            mystruct.rand_cdf_P = gsl_cdf_poisson_P (yy, mu);
            mystruct.rand_cdf_Q = gsl_cdf_poisson_Q (yy, mu);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_poisson (r, mu);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_poisson_pdf(yy, mu);
            mystruct.rand_cdf_P = gsl_cdf_poisson_P (yy, mu);
            mystruct.rand_cdf_Q = gsl_cdf_poisson_Q (yy, mu);
        }
    }

    if (distribution == 25)  //returns 0 or 1 !!!!!!!!!!!!!!!!!!!!!!
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tBINOMIAL(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for 'p' where 0<p<1,\
                   \nand an unsigned int (pos) value for 'n'\
                   \nwhere 'n' is the same as the highest midi\
                   \nnote value for a pitch\
                   \nEx. (0.02, 127): ");
            scanf("%lf, %u",&p, &n);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_binomial (r, p, n);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_binomial_pdf(yy, p, n);
            mystruct.rand_cdf_P = gsl_cdf_binomial_P (yy, p, n);
            mystruct.rand_cdf_Q = gsl_cdf_binomial_Q (yy, p, n);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            gsl_ran_binomial (r, p, n);
            yy = gsl_ran_binomial (r, p, n);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_binomial_pdf(yy, p, n);
            mystruct.rand_cdf_P = gsl_cdf_binomial_P (yy, p, n);
            mystruct.rand_cdf_Q = gsl_cdf_binomial_Q (yy, p, n);
        }
    }

    if (distribution == 26)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tNEGATIVE_BINOMIAL(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for 'p', and 'n'\
                   \nEx. (0.25, 0.50): ");
            scanf("%lf, %lf",&p, &nn);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_negative_binomial (r, p, nn);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_negative_binomial_pdf(yy, p, nn);
            mystruct.rand_cdf_P = gsl_cdf_negative_binomial_P (yy, p, nn);
            mystruct.rand_cdf_Q = gsl_cdf_negative_binomial_Q (yy, p, nn);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_negative_binomial (r, p, nn);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_negative_binomial_pdf(yy, p, nn);
            mystruct.rand_cdf_P = gsl_cdf_negative_binomial_P (yy, p, nn);
            mystruct.rand_cdf_Q = gsl_cdf_negative_binomial_Q (yy, p, nn);
        }
    }

    if (distribution == 27)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tPASCAL(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for 'p',where 0<p<1,\
                   \nand and unsigned int (pos) value for 'n'\
                   \nwhere 'n' is roughly half the highest midi\
                   \nnote value for a pitch\
                   \nEx. (0.99, 56): ");
            scanf("%lf, %u",&p, &n);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_pascal (r, p, n);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_pascal_pdf (yy, p, n);
            mystruct.rand_cdf_P = gsl_cdf_pascal_P (yy, p, n);
            mystruct.rand_cdf_Q = gsl_cdf_pascal_Q (yy, p, n);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_pascal (r, p, n);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_pascal_pdf (yy, p, n);
            mystruct.rand_cdf_P = gsl_cdf_pascal_P (yy, p, n);
            mystruct.rand_cdf_Q = gsl_cdf_pascal_Q (yy, p, n);
        }
    }

    if (distribution == 28)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tGEOMETRIC(GSL) DISTRIBUTION\n");
            //    printf("\t\t\t***** PITCHES *****");
            // Geometric and Hypergeomteric distributions tend towards
            // YY = 2, 3, or 4, where mystruct.randistribution = .5, .33, or .25
            // Thus pitches.c f=(int)(u*h-1)+1 will reject all except 2 or .5.
            // For these two distributions the lowest midi pitch should be 1,
            // then use sort pitches to transpose into audible range.
            printf("\n");
            printf("Enter a double value for 'p', Ex. (0.5): ");
            scanf("%lf",&p);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_geometric (r, p);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_geometric_pdf (yy, p);
            mystruct.rand_cdf_P = gsl_cdf_geometric_P (yy, p);
            mystruct.rand_cdf_Q = gsl_cdf_geometric_Q (yy, p);
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_geometric (r, p);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_geometric_pdf (yy, p);
            mystruct.rand_cdf_P = gsl_cdf_geometric_P (yy, p);
            mystruct.rand_cdf_Q = gsl_cdf_geometric_Q (yy, p);
        }
    }

    if (distribution == 29)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tHYPERGEOMETRIC(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter unsigned int (pos) values for 'n1','n2', and 't'.\
\nt <= n_1 + n_2. Range of randist is max(0,t-n_2), ..., min(t,n_1).\
\nEx. (10, 1, 3): ");
            scanf("%u, %u, %u",&n1, &n2, &t);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_hypergeometric (r, n1, n2, t);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_hypergeometric_pdf (yy, n1, n2, t);
            mystruct.rand_cdf_P = gsl_cdf_hypergeometric_P (yy, n1, n2, t);
            mystruct.rand_cdf_Q = gsl_cdf_hypergeometric_Q (yy, n1, n2, t);
        }
        else
        {
            reset_hypergeometric:
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_hypergeometric (r, n1, n2, t);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_hypergeometric_pdf (yy, n1, n2, t);
             //to avoid NAN error from the GSL distribution
            if(mystruct.rand_pdf!=mystruct.rand_pdf)
            {
                goto reset_hypergeometric;
                pdfcounter++;
                if (pdfcounter > 1000)
                {
                    mystruct.rand_pdf = 0.0;
                    goto cont_hypergeometric;
                }
            }
            cont_hypergeometric:
            mystruct.rand_cdf_P = gsl_cdf_hypergeometric_P (yy, n1, n2, t);
            mystruct.rand_cdf_Q = gsl_cdf_hypergeometric_Q (yy, n1, n2, t);
        }
    }

    if (distribution == 30)
    {
        if (distcounter == 1)
        {
            printf("\n\t\t\tLOGARITHMIC(GSL) DISTRIBUTION\n");
            printf("\n");
            printf("Enter a double value for 'p', Ex. (0.99): ");
            scanf("%lf",&p);
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_logarithmic (r, p);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_logarithmic_pdf (yy, p);
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A
        }
        else
        {
            mystruct.rannum = gsl_rng_get (r);
            mystruct.ranmin = gsl_rng_min (r);
            mystruct.ranmax = gsl_rng_max (r);
            mystruct.ranuniform = gsl_rng_uniform (r);
            mystruct.ranuniformpos = gsl_rng_uniform_pos (r);
            yy = gsl_ran_logarithmic (r, p);
            mystruct.randistribution = (double)1/(double)yy;
            mystruct.rand_pdf = gsl_ran_logarithmic_pdf (yy, p);
            mystruct.rand_cdf_P = 0.0; //N/A
            mystruct.rand_cdf_Q = 0.0; //N/A
        }
    }

    return(mystruct); //return type is struct
}
