#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>

#define  MAX_LEVELS  300

int *velocitysort(int *thereturnarray, int numvelocities)
{
    char c;
    char sortname[20];
    int *s, *sc; //local arrays sort, and sortcopy
    int l,h, i, x, y;
    int velocitynums, velocitysort;
    int gainnum, samenum, slotnum;
    int stepnum, stepinc, steprange;
    int counter, startnum, limitnum;
    char filepath[256];
    char pathappend[256];
    strcpy(filepath, "/opt/csound516");
    strcpy(pathappend, "/velocitysort.txt");
    strcat(filepath, pathappend);
    FILE *outf;
    velocitynums = numvelocities - 1;

first:
    //***************************************
//*****  SELECT RANDOM DISTRIBUTION *****
//***************************************
    printf("\n");
    printf("\t\t\t***** SORT VELOCITIES *****");
    printf("\n1 = crescendo, 2 = decrescendo, 3 = retrograde, 4 = inverted\
            \n5 = retrograde inv, 6 = palindrome, 7 = inv palindrome\
            \n8 = gain, 9 = rotation, 10 = all same\
            \n11 = step up, 12 = step down, 13 = none(exit)\
     \n\nEnter a sort process for velocities:  ");
    scanf("%d",&velocitysort);

    s=(int*)calloc(1000,sizeof(int));/*pointer 's' is allocated 1000
				  integers and treated like an array */
    sc=(int*)calloc(1000,sizeof(int));/*pointer 'sc' is allocated 1000
				  integers and treated like an array */

//***************************************
//********  SORT LOOPS ***********
//***************************************

//**********************
//***** accending *****
//**********************
    if (velocitysort == 1)
    {
        strcpy(sortname, "ascending");
        printf("%s\n", sortname);

        for (i=1; i<=velocitynums; i++)
        {
            s[i]=thereturnarray[i];
        }
//reference for this quicksort algorithm
//http://alienryderflex.com/quicksort/
//could have been done with GSL but this algo gives good results
        int  piv, beg[MAX_LEVELS], end[MAX_LEVELS], i=0, L, R, swap ;

//sort the local array 's' lowest to highest
        beg[0]=0;
        end[0]=velocitynums+1;
        while (i>=0)
        {
            L=beg[i];
            R=end[i]-1;
            if (L<R)
            {
                piv=s[L];
                while (L<R)
                {
                    while (s[R]>=piv && L<R) R--;
                    if (L<R) s[L++]=s[R];
                    while (s[L]<=piv && L<R) L++;
                    if (L<R) s[R--]=s[L];
                }
                s[L]=piv;
                beg[i+1]=L+1;
                end[i+1]=end[i];
                end[i++]=L;
                if (end[i]-beg[i]>end[i-1]-beg[i-1])
                {
                    swap=beg[i];
                    beg[i]=beg[i-1];
                    beg[i-1]=swap;
                    swap=end[i];
                    end[i]=end[i-1];
                    end[i-1]=swap;
                }
            }
            else
            {
                i--;
            }
        }
    } //end ascending

//**********************
//***** descending *****
//**********************
    if (velocitysort == 2)
    {
        strcpy(sortname, "descending");
        printf("%s\n", sortname);
        //load original pitch nums into local array 's'
        for (i=1; i<=velocitynums; i++)
        {
            s[i]=thereturnarray[i];
        }
//uses same quicksort algo from "ascending" sort
        int  piv, beg[MAX_LEVELS], end[MAX_LEVELS], i=0, L, R, swap ;

//sort the local array 's' lowest to highest
        beg[0]=0;
        end[0]=velocitynums+1;
        while (i>=0)
        {
            L=beg[i];
            R=end[i]-1;
            if (L<R)
            {
                piv=s[L];
                while (L<R)
                {
                    while (s[R]>=piv && L<R) R--;
                    if (L<R) s[L++]=s[R];
                    while (s[L]<=piv && L<R) L++;
                    if (L<R) s[R--]=s[L];
                }
                s[L]=piv;
                beg[i+1]=L+1;
                end[i+1]=end[i];
                end[i++]=L;
                if (end[i]-beg[i]>end[i-1]-beg[i-1])
                {
                    swap=beg[i];
                    beg[i]=beg[i-1];
                    beg[i-1]=swap;
                    swap=end[i];
                    end[i]=end[i-1];
                    end[i-1]=swap;
                }
            }
            else
            {
                i--;
            }
        }

        //'sc' becomes retrograde of sorted array 's'
        x = 1;
        for(i=velocitynums; i>=1; i--)
        {
            sc[x]= s[i];
            x++;
        }
        //loads retrograde back into 's'
        for (i=1; i<=velocitynums; i++)
        {
            s[i]= sc[i];
        }
    } //end descending

//**********************
//***** retrograde *****
//**********************
    if (velocitysort == 3)
    {
        strcpy(sortname, "retrograde");
        x = 1;
        for(i=velocitynums; i>=1; i--)
        {
            s[x]= thereturnarray[i];
            x++;
        }
    } //end retrograde

//**********************
//***** inverted *****
//**********************
    if (velocitysort == 4)
    {
//TODO if midi nums are > 127, transpose by one octave
        strcpy(sortname, "inverted");
        printf("%s\n", sortname);

        //invert within the space of '12'
        for (i=1; i<=velocitynums; i++)
        {
            sc[i] = thereturnarray[i]-(thereturnarray[i]%12);
            s[i]= 12-((thereturnarray[i])%12);
            s[i] = s[i] + sc[i];
        }
    } //end inverted

//**********************
//***** retrograde inverted *****
//**********************
    if (velocitysort == 5)
    {
        strcpy(sortname, "retrograde inverted");
        printf("%s\n", sortname);

        //invert within the space of '12'
        for (i=1; i<=velocitynums; i++)
        {
            sc[i] = thereturnarray[i]-(thereturnarray[i]%12);
            s[i]= 12-((thereturnarray[i])%12);
            s[i] = s[i] + sc[i];
        }
        //'sc' becomes retrograde of inverted array 's'
        x = 1;
        for(i=velocitynums; i>=1; i--)
        {
            sc[x]= s[i];
            x++;
        }
        //loads retrograde back into 's'
        for (i=1; i<=velocitynums; i++)
        {
            s[i]= sc[i];
        }
    } //end retrograde inverted

//**********************
//***** palindrome *****
//**********************
//Not a true palindrom. Only ascending and descending.
    if (velocitysort == 6)
    {
        strcpy(sortname, "palindrome");
        printf("%s\n", sortname);

//load original pitch nums into local array 's'
        for (i=1; i<=velocitynums; i++)
        {
            s[i]=thereturnarray[i];
        }

//same quicksort algo as above
        int  piv, beg[MAX_LEVELS], end[MAX_LEVELS], i=0, L, R, swap ;

//sort the local array 's' lowest to highest
        beg[0]=0;
        end[0]=velocitynums+1;
        while (i>=0)
        {
            L=beg[i];
            R=end[i]-1;
            if (L<R)
            {
                piv=s[L];
                while (L<R)
                {
                    while (s[R]>=piv && L<R) R--;
                    if (L<R) s[L++]=s[R];
                    while (s[L]<=piv && L<R) L++;
                    if (L<R) s[R--]=s[L];
                }
                s[L]=piv;
                beg[i+1]=L+1;
                end[i+1]=end[i];
                end[i++]=L;
                if (end[i]-beg[i]>end[i-1]-beg[i-1])
                {
                    swap=beg[i];
                    beg[i]=beg[i-1];
                    beg[i-1]=swap;
                    swap=end[i];
                    end[i]=end[i-1];
                    end[i-1]=swap;
                }
            }
            else
            {
                i--;
            }
        }
        //'sc' becomes retrograde of sorted array 's'
        x = 1;
        for(i=velocitynums; i>=1; i--)
        {
            sc[x]= s[i];
            x++;
        }
        //adds retrograde to end of 's'
        for (i=x; i<= (velocitynums + (x-1)); i++)
        {
            s[i]= sc[i-velocitynums];
        }
        //selects the pitches based on modulo
        h=1;
        for (i=1; i<= (velocitynums+(x-1)); i++)
        {
            if (i % 2 == 0 && i <= velocitynums)
            {
                sc[h] = s[i];
                h++;
            }
            if (i % 2 == 0 && i > velocitynums)
            {
                sc[h] = s[i];
                h++;
            }
        }
        //copies sc back to s for output, below
        for(i=1; i<=velocitynums; i++)
        {
            s[i] = sc[i];
        }

        //zeros the above retrograde added numbers
        //so main.c sees the the zeros when counting
        for(i=velocitynums; i<= (velocitynums+(x-1)); i++)
        {
            if (i > velocitynums)
            {
              s[i] = 0;
            }
        }
    } //end of palindrome



//**************************
//***** inv palindrome *****
//**************************
//Not a true palindrom. Only descending and ascending.
    if (velocitysort == 7)
    {
        strcpy(sortname, " inv palindrome");
        printf("%s\n", sortname);

//load original pitch nums into local array 's'
        for (i=1; i<=velocitynums; i++)
        {
            s[i]=thereturnarray[i];
        }

//same quicksort algo as above
        int  piv, beg[MAX_LEVELS], end[MAX_LEVELS], i=0, L, R, swap ;

//sort the local array 's' lowest to highest
        beg[0]=0;
        end[0]=velocitynums+1;
        while (i>=0)
        {
            L=beg[i];
            R=end[i]-1;
            if (L<R)
            {
                piv=s[L];
                while (L<R)
                {
                    while (s[R]>=piv && L<R) R--;
                    if (L<R) s[L++]=s[R];
                    while (s[L]<=piv && L<R) L++;
                    if (L<R) s[R--]=s[L];
                }
                s[L]=piv;
                beg[i+1]=L+1;
                end[i+1]=end[i];
                end[i++]=L;
                if (end[i]-beg[i]>end[i-1]-beg[i-1])
                {
                    swap=beg[i];
                    beg[i]=beg[i-1];
                    beg[i-1]=swap;
                    swap=end[i];
                    end[i]=end[i-1];
                    end[i-1]=swap;
                }
            }
            else
            {
                i--;
            }
        }

        //'sc' becomes retrograde of sorted array 's'
        //becomes high to low
        x = 1;
        for(i=velocitynums; i>=1; i--)
        {
            sc[x]= s[i];
            //Debug
            //printf(" %d ", sc[x]);
            x++;
        }

        //adds retrograde to end of 's'
        //becomes high to low, then add low to high
        for (i=x; i<= (velocitynums + (x-1)); i++)
        {
            sc[i]= s[i-velocitynums];
        }

        //selects the pitches based on modulo
        h=1;
        for (i=1; i<= (velocitynums+(x-1)); i++)
        {
            if (i % 2 == 0 && i <= velocitynums)
            {
                s[h] = sc[i];
                h++;
            }
            if (i % 2 == 0 && i > velocitynums)
            {
                s[h] = sc[i];
                h++;
            }
        }

        //zeros the above retrograde added numbers
        //so main.c sees the the zeros when counting
        for(i=velocitynums; i<= (velocitynums+(x-1)); i++)
        {
            if (i > velocitynums)
            {
              s[i] = 0;
            }
        }
    } //end of inv palindrome


//**********************
//***** transposition *****
//**********************
    if (velocitysort == 8)
    {
        strcpy(sortname, "gain");
        printf("%s\n", sortname);
        printf("Enter an amount for gain(ex. +1, or -1): ");
        scanf("%d",&gainnum);

        for (i=1; i<=velocitynums; i++)
        {
            s[i]= thereturnarray[i] + (gainnum);
        }
    } //end gain

//**********************
//***** rotation *****
//**********************
    if (velocitysort == 9)
    {
        strcpy(sortname, "rotation");
        printf("%s\n", sortname);

        for (i=1; i<=velocitynums; i++)
        {
            printf(" %d:[%d] ", i,thereturnarray[i]);
        }

        printf("\n\nEnter a slot number for rotation (ex. 5): ");
        scanf("%d",&slotnum);

        for (i=1; i<=velocitynums; i++)
        {
            x=(i-1)+slotnum;
            if (x>velocitynums)
            {
                s[i]= thereturnarray[x-velocitynums];
            }
            else
                s[i]= thereturnarray[(i-1)+slotnum];
        }
    } //end rotation

//**********************
//***** all same *****
//**********************
    if (velocitysort == 10)
    {
        strcpy(sortname, "all same");
        printf("%s\n", sortname);
        printf("Enter a midi num for velocity: ");
        scanf("%d",&samenum);

        for (i=1; i<=velocitynums; i++)
        {
            s[i]= samenum;
        }
    } //end all same


//**********************
//***** step up *****
//**********************
//stepup and stepdown have nothing to do
//with the random distributions, above
    if (velocitysort == 11)
    {
        strcpy(sortname, "step up");
        printf("%s\n", sortname);
        printf("Enter the num of steps over %d pitches: ", velocitynums);
        scanf("%d",&stepnum);

        if (stepnum>=velocitynums)
        {
            printf("\nsteps greater or equal to num of velocities\n");
            goto first;
        }

        if (stepnum==1)
        {
            printf("\nuse 'all same'\n");
            goto first;
        }

        stepinc = (int)(velocitynums/stepnum);

stepupstart:
        printf("\nEnter lowest midi note value for a velocity:");
        scanf("%d", &l);
        printf("\nEnter highest midi note value for a velocity:");
        scanf("%d", &h);
        if(h-1<=1) /*loop placed here as a precaution*/
        {
            goto stepupstart;
        }
        //h=h+1;/* highest no. gets plus one */

        steprange = h - l;

        if (stepnum == 2)
        {
            for (i=1; i<=stepinc; i++)
            {
                s[i]= l;
            }
            for (i=stepinc+1; i<=velocitynums; i++)
            {
                s[i]= h;
            }
        }

        if (stepnum > 2)
        {
            x = 0;
            y = (int)(velocitynums/stepinc) -1;
            counter = 1;

            while (counter<=(int)velocitynums/stepinc)
            {
                startnum = stepinc * x;
                limitnum = velocitynums - (stepinc * y);
                for (i= startnum+1; i<=limitnum ; i++)
                {
                    if (x < stepnum - 1)
                        s[i]= l + ((int)(steprange/(stepnum-1))*x);
                    if (x == stepnum -1)
                        s[i]= h;
                }
                x++;
                y--;

                counter++;
            }

        } //end if > 2

    } //end step up


//**********************
//***** step down *****
//**********************
    if (velocitysort == 12)
    {
        strcpy(sortname, "step down");
        printf("%s\n", sortname);
        printf("Enter the num of steps over %d pitches: ", velocitynums);
        scanf("%d",&stepnum);

        if (stepnum>=velocitynums)
        {
            printf("\nsteps greater or equal to num of velocities\n");
            goto first;
        }

        if (stepnum==1)
        {
            printf("\nuse 'all same'\n");
            goto first;
        }

        stepinc = (int)(velocitynums/stepnum);

stepdownstart:
        printf("\nEnter lowest midi note value for a velocity:");
        scanf("%d", &l);
        printf("\nEnter highest midi note value for a velocity:");
        scanf("%d", &h);
        if(h-1<=1) /*loop placed here as a precaution*/
        {
            goto stepdownstart;
        }
        steprange = h - l;

        if (stepnum == 2)
        {
            for (i=1; i<=stepinc; i++)
            {
                s[i]= l;
            }
            for (i=stepinc+1; i<=velocitynums; i++)
            {
                s[i]= h;
            }
        }

        if (stepnum > 2)
        {
            x = 0;
            y = (int)(velocitynums/stepinc) -1;
            counter = 1;

            while (counter<=(int)velocitynums/stepinc)
            {
                startnum = stepinc * x;
                limitnum = velocitynums - (stepinc * y);
                for (i= startnum+1; i<=limitnum ; i++)
                {
                    if (x < stepnum - 1)
                        s[i]= l + ((int)(steprange/(stepnum-1))*x);
                    if (x == stepnum -1)
                        s[i]= h;
                }
                x++;
                y--;

                counter++;
            }

        } //end if > 2

        //'sc' becomes retrograde of sorted array 's'
        x = 1;
        for(i=velocitynums; i>=1; i--)
        {
            sc[x]= s[i];
            x++;
        }
        //loads retrograde back into 's'
        for (i=1; i<=velocitynums; i++)
        {
            s[i]= sc[i];
        }

    } //ends step down

//**********************
//***** none *****
//**********************
    if (velocitysort == 13)
    {
        strcpy(sortname, "none");
        printf("%s\n", sortname);

        for (i=1; i<=velocitynums; i++)
        {
            printf(" %d ", thereturnarray[i]);
        }

        for (i=1; i<=velocitynums; i++)
        {
            s[i]= thereturnarray[i];
        }
    } //end none

//***************************************
//********  PRINT PITCHES ***********
//***************************************
closing:
    printf("\n...from velocitysort.c\n");
    printf("original\n");
    for (x=1; x<=velocitynums; x++)
    {
        printf("%4d",thereturnarray[x]);/*prints numbers */
    }
    printf("\n%s\n", sortname);
    for (x=1; x<=velocitynums; x++)
    {
        printf("%4d",s[x]);/*prints numbers */
    }
    printf("\n");

//****************************************
//********  User Switch to resort using sorted *****
//****************************************

userswitch1:
    //printf("\n");
    printf("\nResort using %s?  (y)es, (n)o: ", sortname);
    while (getchar()!='\n');
    scanf("%c", &c);
    switch(c)
    {
    case 'y':
        for (i=1; i<=velocitynums; i++)
        {
            thereturnarray[i] = s[i];
        }
        free(s); //free memory
        free(sc);
        goto first;

    case 'n':
        goto resortno;
    default:
        //break;
        printf("\n...enter (y)es, or (n)o: \n");
        goto userswitch1;
    } //ends switch
resortno:

//****************************************
//** User Switch to save to keep original or sorted series **
// (contains old code to save series to text file)
//****************************************
userswitch2:
    //printf("\n");
    printf("\nKeep original, or %s? (o)riginal, (s)orted: ", sortname);
    while (getchar()!='\n');
    scanf("%c", &c);
    switch(c)
    {
//    case 't':
//    //printf("\n...Saving to filepath: %s\n", filepath);
//        if((outf = fopen(filepath, "w")) != NULL)
//        {
//            fprintf(outf, "\n...from pitchsort.c\n");
//            fprintf(outf, "original\n");
//            for (x=1; x<=pitchnums; x++)
//            {
//                fprintf(outf, "%4d",thereturnarray[x]);/*prints numbers */
//            }
//            fprintf(outf, "\n%s\n", sortname);
//            for (x=1; x<=pitchnums; x++)
//            {
//                fprintf(outf, "%4d",s[x]);/*prints numbers */
//            }
//        printf("File saved to:");
//        printf("%s\n", filepath);
//        }
//        else
//        {
//            printf("May need to set correct file path in pitchsort.c");
//        }
//        fclose(outf);
//        goto closing;
    case 'o':
        for (x=1; x<=velocitynums; x++)
        {
            s[x] = thereturnarray[x];
        }
        free(sc);
        goto last;
    case 's':
        for (i=1; i<=velocitynums; i++)
        {
            thereturnarray[i] = s[i];
        }
        for (i=1; i<=velocitynums; i++)
        {
            s[i] = thereturnarray[i];
        }
        free(sc);
        goto last;
    default:
        //break;
        printf("\n...enter (s)orted, or (o)riginal: \n");
        goto userswitch2;
    } //ends switch
last:

    return s;
} //ends velocity.c

