<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

sr = 44100
ksmps = 128
nchnls = 2
0dbfs  = 1

#define Clock #10#
#define TableReader #20#
#define OSCSendMetronome #30#
#define OSCReceive #40#

gi_OSCHandle OSCinit 10001


instr Init, 1

		turnon $Clock
		turnon $TableReader
		turnon $OSCSendMetronome
  		turnon $OSCReceive

		gk_ButtonNumber init 0
		gk_ButtonState init 0

		gi_MetroTable ftgen 0, 0, 8, -2, 0, 1, 2, 3, 4, 5, 6, 7
		gi_TriggerTable ftgen 0, 0, 8, -2, 0, 0, 0, 0, 0, 0, 0, 0

endin

instr Clock, 10

	gk_Phasor phasor 1
endin

instr TableReader, 20

		gk_Metronome table gk_Phasor, gi_MetroTable, 1

		k_Trigger table gk_Phasor, gi_TriggerTable, 1

		k_Gate init 0

		k_StopTime init 0

		k_Timer times

		if (k_Trigger == 1 && k_Gate == 0) then

			event "i", "Beep", 0, 1/8

			k_StopTime = k_Timer + (1/8)
			k_Gate = 1

		endif


		if (k_Timer > k_StopTime) then


			k_Gate = 0 

		endif 

endin 

instr OSCSendMetronome, 30

     OSCsend gk_Metronome, "127.0.0.1", 20002, "/phasor", "f", gk_Metronome

endin 

instr OSCReceive, 40
		nxtmsg:

		k_OSCReceived OSClisten gi_OSCHandle, "/buttons", "ii", gk_ButtonNumber, gk_ButtonState
    		
		if (k_OSCReceived == 0) goto ex
		
			if (gk_ButtonState == 1) then

				event "i", "TableWriter", 0, -1

			endif


		kgoto nxtmsg
		ex:
endin

instr TableWriter, 50
		
		k_CurrentValue table gk_ButtonNumber, gi_TriggerTable
		
		if (k_CurrentValue == 0) then

			tablew 1, gk_ButtonNumber, gi_TriggerTable
		else
			
			tablew 0, gk_ButtonNumber, gi_TriggerTable
		endif

		event "i", "OSCSendTableState", 0, -1

		turnoff
endin

instr OSCSendTableState, 60
      
		k0 table 0, gi_TriggerTable
		k1 table 1, gi_TriggerTable
		k2 table 2, gi_TriggerTable
		k3 table 3, gi_TriggerTable
		k4 table 4, gi_TriggerTable
		k5 table 5, gi_TriggerTable
		k6 table 6, gi_TriggerTable
		k7 table 7, gi_TriggerTable
		
		OSCsend 1, "127.0.0.1", 20002, "/tablestate", "ffffffff", k0, k1, k2, k3, k4, k5, k6, k7

		turnoff
endin

instr Beep 
		
		a_Out vco2 .2, 220
		outs a_Out, a_Out

endin 


</CsInstruments>
<CsScore>
i "Init" 0 100
</CsScore>
</CsoundSynthesizer>